//Description:  	This program handels a sequential database file. It allows
//				  	 	the creation of a file then the input of records. The data
//					 	in the file can then be redisplayed on the screen.
//Programmer:	  	Mark Solly
//Creation Date:	21/10/1999
//Last Updated: 	21/10/1999

//Headder include files
#include <iostream.h>
#include <conio.h>
#include <fstream.h>

//Global variable declarations
char actfile[30];
char cmdchar;
char cmdexit = 'n';

//Data structure decleration
struct art_record
{
	char fname[10];
	char lname[20];
	char address[30];
	char phonenum[7];
	char gstno[10];
	char usualtype[12];
	char usualmed[8];
	char usualstyle[16];
	int slastyear;
	int stodate;
};

//Function declarations
void main();
void linefeed(int lines);
void linefill(int width, char fillchr);
void startnew();

//Main program function
void main()
{
	clrscr();
	linefeed(4);
	linefill(40,'=');
	cout << "\t\t     WELCOME TO THE ART GALLERY DATABASE";
	linefill(40,'=');
	linefeed(4);
	cout << "\t\t  Please enter the name of the file you wish\n";
	cout << "\t\t  to create or work with: ";
	cin >> actfile;  //Getting file name

	while(cmdexit != 'y')  //Main menu loop
	{
		clrscr();
		linefeed(2);
		linefill(30,'=');
		cout << "\t\t\t     ART GALLERY DATABASE\n\t\t\t\t   Main Menu";
		linefill(30,'=');
		linefeed(2);
		cout << "\t\t  1. Create a file and input records\n\n";
		cout << "\t\t  2. Append a record to the existing file\n\n";
		cout << "\t\t  3. Read and display the records in the file\n\n";
		cout << "\t\t  4. Exit";
		linefeed(3);
		cout << "\t\tPlease enter the number next to the menu\n";
		cout << "\t\titem you wish to choose: ";
		cin >> cmdchar;

		switch(cmdchar)
		{
			//Processing choice from main menu
			case '1':
				startnew();
				break;
			case '2':
				break;
			case '3':
				break;
			case '4':  //Quit program
				cmdexit = 'y';
				break;
			default:
				break;
		}
	}
}

void startnew()
{
	//This function creates a new file and prompts for data to be entered
	char ans;

	while(ans != 'y' && ans != 'Y' && ans != 'n' && ans != 'N')
	{
		clrscr();
		linefeed(2);
		linefill(29,'=');
		cout << "\t\t\t    ART GALLERY DATABASE\n\t\t\t  Create New Database File";
		linefill(29,'=');
		linefeed(4);

		//Check if it is ok to overwrte the active file
		cout << "\t\tYou are curently using the folowing file: " << actfile;
		cout << "\n\n\t\tWould you like to over write this file and loose\n";
		cout << "\t\tall its contents?\n\n\t\t";
		cout << "Choose y for yes or n to pick a different file: ";
		cin >> ans;
	}

	if(ans == 'n' || ans == 'N')
	{
		clrscr();
		linefeed(2);
		linefill(29,'=');
		cout << "\t\t\t    ART GALLERY DATABASE\n\t\t\t  Create New Database File";
		linefill(29,'=');
		linefeed(4);
		cout << "\t\t  Please enter the name of the file you wish\n";
		cout << "\t\t  to create: ";
		cin >> actfile;  //Getting file name
	}
}

//THE FOLOWING SECTION CONTAINS SCREEN LAYOUT FUNCTIONS

void linefeed(int lines)
{
	//This function feeds blank lines to the screen
	for(int i = 0; i < lines; i++)
	{
		cout << "\n";
	}
}

void linefill(int width, char fillchr)
{
	//This function prints a line of char's specified in 'fillchr' and
	//centers them across the screen.
	//Use 'width' to control how wide the line is.

	int space = (80 - width) / 2;  //Measure no. of leading spaces
	cout << "\n";

	for(int i = 1; i < space; i++)
	{
		cout << " ";  //Print leading spaces to place line in center
	}

	for(i = 1; i < width; i++)
	{
		cout << fillchr; // Print line
	}
	cout << "\n";
}


